diff -r fb51f5b4aa4c trytond/tests/test_fields.py
--- a/trytond/tests/test_fields.py	Mon Sep 24 11:36:39 2012 +0200
+++ b/trytond/tests/test_fields.py	Mon Sep 24 20:36:36 2012 +0200
@@ -2126,251 +2018,239 @@
             night = datetime.time(20, 00)
             default_time = datetime.time(16, 30)
 
-            time1_id = self.time.create({
+            time1 = self.time.create({
                     'time': evening,
                     })
-            self.assert_(time1_id)
-
-            time1 = self.time.read(time1_id, ['time'])
-            self.assertEqual(time1['time'], evening)
-
-            time_ids = self.time.search([
-                ('time', '=', evening),
-                ])
-            self.assert_(time_ids == [time1_id])
-
-            time_ids = self.time.search([
-                ('time', '=', night),
-                ])
-            self.assert_(time_ids == [])
-
-            time_ids = self.time.search([
-                ('time', '=', False),
-                ])
-            self.assert_(time_ids == [])
-
-            time_ids = self.time.search([
-                ('time', '!=', evening),
-                ])
-            self.assert_(time_ids == [])
-
-            time_ids = self.time.search([
-                ('time', '!=', night),
-                ])
-            self.assert_(time_ids == [time1_id])
-
-            time_ids = self.time.search([
-                ('time', '!=', False),
-                ])
-            self.assert_(time_ids == [time1_id])
-
-            time_ids = self.time.search([
-                ('time', 'in', [evening]),
-                ])
-            self.assert_(time_ids == [time1_id])
-
-            time_ids = self.time.search([
-                ('time', 'in', [night]),
-                ])
-            self.assert_(time_ids == [])
-
-            time_ids = self.time.search([
-                ('time', 'in', [False]),
-                ])
-            self.assert_(time_ids == [])
-
-            time_ids = self.time.search([
-                ('time', 'in', []),
-                ])
-            self.assert_(time_ids == [])
-
-            time_ids = self.time.search([
-                ('time', 'not in', [evening]),
-                ])
-            self.assert_(time_ids == [])
-
-            time_ids = self.time.search([
-                ('time', 'not in', [night]),
-                ])
-            self.assert_(time_ids == [time1_id])
-
-            time_ids = self.time.search([
-                ('time', 'not in', [False]),
-                ])
-            self.assert_(time_ids == [time1_id])
-
-            time_ids = self.time.search([
-                ('time', 'not in', []),
-                ])
-            self.assert_(time_ids == [time1_id])
-
-            time_ids = self.time.search([
-                ('time', '<', night),
-                ])
-            self.assert_(time_ids == [time1_id])
-
-            time_ids = self.time.search([
-                ('time', '<', pre_evening),
-                ])
-            self.assert_(time_ids == [])
-
-            time_ids = self.time.search([
-                ('time', '<', evening),
-                ])
-            self.assert_(time_ids == [])
-
-            time_ids = self.time.search([
-                ('time', '<=', evening),
-                ])
-            self.assert_(time_ids == [time1_id])
-
-            time_ids = self.time.search([
-                ('time', '<=', pre_evening),
-                ])
-            self.assert_(time_ids == [])
-
-            time_ids = self.time.search([
-                ('time', '<=', night),
-                ])
-            self.assert_(time_ids == [time1_id])
-
-            time_ids = self.time.search([
-                ('time', '>', night),
-                ])
-            self.assert_(time_ids == [])
-
-            time_ids = self.time.search([
-                ('time', '>', pre_evening),
-                ])
-            self.assert_(time_ids == [time1_id])
-
-            time_ids = self.time.search([
-                ('time', '>', evening),
-                ])
-            self.assert_(time_ids == [])
-
-            time_ids = self.time.search([
-                ('time', '>=', night),
-                ])
-            self.assert_(time_ids == [])
-
-            time_ids = self.time.search([
-                ('time', '>=', pre_evening),
-                ])
-            self.assert_(time_ids == [time1_id])
-
-            time_ids = self.time.search([
-                ('time', '>=', evening),
-                ])
-            self.assert_(time_ids == [time1_id])
-
-            time2_id = self.time.create({
-                'time': pre_evening,
-                })
-            self.assert_(time2_id)
-
-            time2 = self.time.read(time2_id, ['time'])
-            self.assert_(time2['time'] == pre_evening)
-
-            time_ids = self.time.search([
-                ('time', '=', pre_evening),
-                ])
-            self.assert_(time_ids == [time2_id])
-
-            time_ids = self.time.search([
-                ('time', 'in', [pre_evening, evening]),
-                ])
-            self.assert_(time_ids == [time1_id, time2_id])
-
-            time_ids = self.time.search([
-                ('time', 'not in', [pre_evening, evening]),
-                ])
-            self.assert_(time_ids == [])
-
-            time3_id = self.time.create({})
-            self.assert_(time3_id)
-
-            time3 = self.time.read(time3_id, ['time'])
-            self.assert_(time3['time'] == None)
-
-            time4_id = self.time_default.create({})
-            self.assert_(time4_id)
-
-            time4 = self.time_default.read(time4_id, ['time'])
-            self.assert_(time4['time'] == default_time)
-
-            self.time.write(time1_id, {
-                'time': pre_evening,
-                })
-            time1 = self.time.read(time1_id, ['time'])
-            self.assert_(time1['time'] == pre_evening)
-
-            self.time.write(time2_id, {
-                'time': evening,
-                })
-            time2 = self.time.read(time2_id, ['time'])
-            self.assert_(time2['time'] == evening)
-
-            self.failUnlessRaises(Exception, self.time.create, {
+            self.assert_(time1)
+            self.assertEqual(time1.time, evening)
+
+            times = self.time.search([
+                    ('time', '=', evening),
+                    ])
+            self.assertEqual(times, [time1])
+
+            times = self.time.search([
+                    ('time', '=', night),
+                    ])
+            self.assertEqual(times, [])
+
+            times = self.time.search([
+                    ('time', '=', None),
+                    ])
+            self.assertEqual(times, [])
+
+            times = self.time.search([
+                    ('time', '!=', evening),
+                    ])
+            self.assertEqual(times, [])
+
+            times = self.time.search([
+                    ('time', '!=', night),
+                    ])
+            self.assertEqual(times, [time1])
+
+            times = self.time.search([
+                    ('time', '!=', None),
+                    ])
+            self.assertEqual(times, [time1])
+
+            times = self.time.search([
+                    ('time', 'in', [evening]),
+                    ])
+            self.assertEqual(times, [time1])
+
+            times = self.time.search([
+                    ('time', 'in', [night]),
+                    ])
+            self.assertEqual(times, [])
+
+            times = self.time.search([
+                    ('time', 'in', [None]),
+                    ])
+            self.assertEqual(times, [])
+
+            times = self.time.search([
+                    ('time', 'in', []),
+                    ])
+            self.assertEqual(times, [])
+
+            times = self.time.search([
+                    ('time', 'not in', [evening]),
+                    ])
+            self.assertEqual(times, [])
+
+            times = self.time.search([
+                    ('time', 'not in', [night]),
+                    ])
+            self.assertEqual(times, [time1])
+
+            times = self.time.search([
+                    ('time', 'not in', [None]),
+                    ])
+            self.assertEqual(times, [time1])
+
+            times = self.time.search([
+                    ('time', 'not in', []),
+                    ])
+            self.assertEqual(times, [time1])
+
+            times = self.time.search([
+                    ('time', '<', night),
+                    ])
+            self.assertEqual(times, [time1])
+
+            times = self.time.search([
+                    ('time', '<', pre_evening),
+                    ])
+            self.assertEqual(times, [])
+
+            times = self.time.search([
+                    ('time', '<', evening),
+                    ])
+            self.assertEqual(times, [])
+
+            times = self.time.search([
+                    ('time', '<=', evening),
+                    ])
+            self.assertEqual(times, [time1])
+
+            times = self.time.search([
+                    ('time', '<=', pre_evening),
+                    ])
+            self.assertEqual(times, [])
+
+            times = self.time.search([
+                    ('time', '<=', night),
+                    ])
+            self.assertEqual(times, [time1])
+
+            times = self.time.search([
+                    ('time', '>', night),
+                    ])
+            self.assertEqual(times, [])
+
+            times = self.time.search([
+                    ('time', '>', pre_evening),
+                    ])
+            self.assertEqual(times, [time1])
+
+            times = self.time.search([
+                    ('time', '>', evening),
+                    ])
+            self.assertEqual(times, [])
+
+            times = self.time.search([
+                    ('time', '>=', night),
+                    ])
+            self.assertEqual(times, [])
+
+            times = self.time.search([
+                    ('time', '>=', pre_evening),
+                    ])
+            self.assertEqual(times, [time1])
+
+            times = self.time.search([
+                    ('time', '>=', evening),
+                    ])
+            self.assertEqual(times, [time1])
+
+            time2 = self.time.create({
+                    'time': pre_evening,
+                    })
+            self.assert_(time2)
+            self.assertEqual(time2.time, pre_evening)
+
+            times = self.time.search([
+                    ('time', '=', pre_evening),
+                    ])
+            self.assertEqual(times, [time2])
+
+            times = self.time.search([
+                    ('time', 'in', [pre_evening, evening]),
+                    ])
+            self.assertEqual(times, [time1, time2])
+
+            times = self.time.search([
+                    ('time', 'not in', [pre_evening, evening]),
+                    ])
+            self.assertEqual(times, [])
+
+            time3 = self.time.create({})
+            self.assert_(time3)
+            self.assertEqual(time3.time, None)
+
+            time4 = self.time_default.create({})
+            self.assert_(time4)
+            self.assertEqual(time4.time, default_time)
+
+            self.time.write([time1], {
+                    'time': pre_evening,
+                    })
+            self.assertEqual(time1.time, pre_evening)
+
+            self.time.write([time2], {
+                    'time': evening,
+                    })
+            self.assertEqual(time2.time, evening)
+
+            self.assertRaises(Exception, self.time.create, {
                     'time': 'test',
                     })
 
-            self.failUnlessRaises(Exception, self.time.write, time1_id,
+            self.assertRaises(Exception, self.time.write, [time1],
                 {
                     'time': 'test',
                     })
 
-            self.failUnlessRaises(Exception, self.time.create, {
+            self.assertRaises(Exception, self.time.create, {
                     'time': 1,
                     })
 
-            self.failUnlessRaises(Exception, self.time.write, time1_id,
+            self.assertRaises(Exception, self.time.write, [time1],
                 {
                     'time': 1,
                     })
 
-            self.failUnlessRaises(Exception, self.time.write, time1_id,
+            self.assertRaises(Exception, self.time.write, [time1],
                 {
                     'time': '25:00:00',
                     })
 
-            time5_id = self.time.create({
-                'time': '12:00:00',
-                })
-            self.assert_(time5_id)
-            time5 = self.time.read(time5_id, ['time'])
-            self.assert_(time5['time'] == datetime.time(12, 0))
-
-            self.failUnlessRaises(Exception, self.time_required.create, {})
+            time5 = self.time.create({
+                    'time': '12:00:00',
+                    })
+            self.assert_(time5)
+            self.assertEqual(time5.time, datetime.time(12, 0))
+
+            self.assertRaises(Exception, self.time_required.create, {})
             transaction.cursor.rollback()
 
-            time6_id = self.time_required.create({
-                'time': evening,
-                })
-            self.assert_(time6_id)
-
-            time7_id = self.time.create({
-                'time': None,
-                })
-            self.assert_(time7_id)
-
-            time8_id = self.time.create({
-                'time': False,
-                })
-            self.assert_(time8_id)
-
-            time9_id = self.time.create({
-                'time': evening.replace(microsecond=1),
-                })
-            self.assert_(time9_id)
-            time9 = self.time.read(time9_id, ['time'])
-            self.assert_(time9['time'] == evening)
+            time6 = self.time_required.create({
+                    'time': evening,
+                    })
+            self.assert_(time6)
+
+            time7 = self.time.create({
+                    'time': None,
+                    })
+            self.assert_(time7)
+
+            time8 = self.time.create({
+                    'time': False,
+                    })
+            self.assert_(time8)
+
+            time9 = self.time.create({
+                    'time': evening.replace(microsecond=1),
+                    })
+            self.assert_(time9)
+            self.assertEqual(time9.time, evening)
 
             # Test format
             self.assert_(self.time_format.create({
                         'time': datetime.time(12, 30),
                         }))
-            self.failUnlessRaises(Exception, self.time_format.create, {
+            self.assertRaises(Exception, self.time_format.create, {
                     'time': datetime.time(12, 30, 25),
                     })
 
@@ -2382,122 +2262,108 @@
         '''
         with Transaction().start(DB_NAME, USER,
                 context=CONTEXT) as transaction:
-            target1_id = self.one2one_target.create({
-                'name': 'target1',
-                })
-            one2one1_id = self.one2one.create({
-                'name': 'origin1',
-                'one2one': target1_id,
-                })
-            self.assert_(one2one1_id)
-
-            one2one1 = self.one2one.read(one2one1_id, ['one2one',
-                'one2one.name'])
-            self.assert_(one2one1['one2one'] == target1_id)
-            self.assert_(one2one1['one2one.name'] == 'target1')
-
-            one2one_ids = self.one2one.search([
-                ('one2one', '=', 'target1'),
-                ])
-            self.assert_(one2one_ids == [one2one1_id])
-
-            one2one_ids = self.one2one.search([
-                ('one2one', '!=', 'target1'),
-                ])
-            self.assert_(one2one_ids == [])
-
-            one2one_ids = self.one2one.search([
-                ('one2one', 'in', [target1_id]),
-                ])
-            self.assert_(one2one_ids == [one2one1_id])
-
-            one2one_ids = self.one2one.search([
-                ('one2one', 'in', [0]),
-                ])
-            self.assert_(one2one_ids == [])
-
-            one2one_ids = self.one2one.search([
-                ('one2one', 'not in', [target1_id]),
-                ])
-            self.assert_(one2one_ids == [])
-
-            one2one_ids = self.one2one.search([
-                ('one2one', 'not in', [0]),
-                ])
-            self.assert_(one2one_ids == [one2one1_id])
-
-            one2one_ids = self.one2one.search([
-                ('one2one.name', '=', 'target1'),
-                ])
-            self.assert_(one2one_ids == [one2one1_id])
-
-            one2one_ids = self.one2one.search([
-                ('one2one.name', '!=', 'target1'),
-                ])
-            self.assert_(one2one_ids == [])
-
-            one2one = self.one2one.browse(one2one1_id)
-            self.assert_(one2one.one2one.name == 'target1')
-
-            one2one2_id = self.one2one.create({
-                'name': 'origin2',
-                })
-            self.assert_(one2one2_id)
-
-            one2one2 = self.one2one.read(one2one2_id, ['one2one'])
-            self.assert_(one2one2['one2one'] == False)
-
-            one2one_ids = self.one2one.search([
-                ('one2one', '=', False),
-                ])
-            self.assert_(one2one_ids == [one2one2_id])
-
-            target2_id = self.one2one_target.create({
-                'name': 'target2',
-                })
-            self.one2one.write(one2one2_id, {
-                'one2one': target2_id,
-                })
-            target2_id = self.one2one_target.search([
-                ('name', '=', 'target2'),
-                ])[0]
-            one2one2 = self.one2one.read(one2one2_id, ['one2one'])
-            self.assert_(one2one2['one2one'] == target2_id)
-
-            self.one2one.write(one2one2_id, {
-                'one2one': False,
-                })
-            one2one2 = self.one2one.read(one2one2_id, ['one2one'])
-            self.assert_(one2one2['one2one'] == False)
-
-            one2one2 = self.one2one.browse(one2one2_id)
-            self.assert_(not one2one2.one2one)
-
-            self.failUnlessRaises(Exception, self.one2one.create, {
-                'name': 'one2one3',
-                'one2one': target1_id,
-                })
+            target1 = self.one2one_target.create({
+                    'name': 'target1',
+                    })
+            one2one1 = self.one2one.create({
+                    'name': 'origin1',
+                    'one2one': target1.id,
+                    })
+            self.assert_(one2one1)
+            self.assertEqual(one2one1.one2one, target1)
+
+            self.assertEqual(self.one2one.read([one2one1.id],
+                    ['one2one.name'])[0]['one2one.name'], 'target1')
+
+            one2ones = self.one2one.search([
+                    ('one2one', '=', 'target1'),
+                    ])
+            self.assertEqual(one2ones, [one2one1])
+
+            one2ones = self.one2one.search([
+                    ('one2one', '!=', 'target1'),
+                    ])
+            self.assertEqual(one2ones, [])
+
+            one2ones = self.one2one.search([
+                    ('one2one', 'in', [target1.id]),
+                    ])
+            self.assertEqual(one2ones, [one2one1])
+
+            one2ones = self.one2one.search([
+                    ('one2one', 'in', [0]),
+                    ])
+            self.assertEqual(one2ones, [])
+
+            one2ones = self.one2one.search([
+                    ('one2one', 'not in', [target1.id]),
+                    ])
+            self.assertEqual(one2ones, [])
+
+            one2ones = self.one2one.search([
+                    ('one2one', 'not in', [0]),
+                    ])
+            self.assertEqual(one2ones, [one2one1])
+
+            one2ones = self.one2one.search([
+                    ('one2one.name', '=', 'target1'),
+                    ])
+            self.assertEqual(one2ones, [one2one1])
+
+            one2ones = self.one2one.search([
+                    ('one2one.name', '!=', 'target1'),
+                    ])
+            self.assertEqual(one2ones, [])
+
+            one2one2 = self.one2one.create({
+                    'name': 'origin2',
+                    })
+            self.assert_(one2one2)
+            self.assertEqual(one2one2.one2one, None)
+
+            one2ones = self.one2one.search([
+                    ('one2one', '=', None),
+                    ])
+            self.assertEqual(one2ones, [one2one2])
+
+            target2 = self.one2one_target.create({
+                    'name': 'target2',
+                    })
+            self.one2one.write([one2one2], {
+                    'one2one': target2.id,
+                    })
+            self.assertEqual(one2one2.one2one, target2)
+
+            self.one2one.write([one2one2], {
+                    'one2one': None,
+                    })
+            self.assertEqual(one2one2.one2one, None)
+
+            self.assertRaises(Exception, self.one2one.create, {
+                    'name': 'one2one3',
+                    'one2one': target1.id,
+                    })
             transaction.cursor.rollback()
 
-            self.failUnlessRaises(Exception, self.one2one.write, one2one2_id, {
-                'one2one': target1_id,
-                })
+            self.assertRaises(Exception, self.one2one.write, [one2one2], {
+                    'one2one': target1.id,
+                    })
             transaction.cursor.rollback()
 
-            self.failUnlessRaises(Exception, self.one2one_required.create, {
-                'name': 'one2one3',
-                })
+            self.assertRaises(Exception, self.one2one_required.create, {
+                    'name': 'one2one3',
+                    })
             transaction.cursor.rollback()
 
-            target3_id = self.one2one_target.create({
-                'name': 'target3_id',
-                })
-
-            one2one3_id = self.one2one_required.create({
-                'name': 'one2one3',
-                'one2one': target3_id,
-                })
-            self.assert_(one2one3_id)
+            target3 = self.one2one_target.create({
+                    'name': 'target3',
+                    })
+
+            one2one3 = self.one2one_required.create({
+                    'name': 'one2one3',
+                    'one2one': target3.id,
+                    })
+            self.assert_(one2one3)
 
             transaction.cursor.rollback()
 
@@ -2511,7 +2377,7 @@
                     (self.one2many, self.one2many_target),
                     (self.one2many_reference, self.one2many_reference_target),
                     ):
-                one2many1_id = one2many.create({
+                one2many1 = one2many.create({
                         'name': 'origin1',
                         'targets': [
                             ('create', {
